#ifndef bqtBufferHH
#define bqtBufferHH

#include <vector>

typedef unsigned char Datatype;

class Buffer
{
    std::vector<Datatype> Buf;
    unsigned readpos, toppos;
    
    void SitDown(); /* Invalidates all pointers to the data. */

public:
    Buffer();
    
    const Datatype *GetBegin() const;/* Returns a pointer to the first unread byte */
    unsigned        GetSize() const; /* Returns the number of unread bytes */
    unsigned        GetFree() const; /* How much can it eat at max         */
    
    /* Feeds the buffer with data */
    void Feed(const Datatype *ptr, unsigned len);
    
    /* Eats data from buffer. Invalidates all pointers to the data. */
    void Eat(unsigned len);
};

#endif
