#include "events.hh"

#include <iostream>

event::event(eventtype t) : type(t)
{
}

event::~event()
{
}



globalevent::globalevent(const std::string &msg) : event(E_GLOBAL), s(msg)
{
}

const std::string &globalevent::getsdata(const std::string &) const
{
    return s;
}

int globalevent::getidata(const std::string &) const
{
    return 0;
}



informevent::informevent(const std::string &n, const std::string &m, int s) : event(E_INFORM), nick(n), msg(m), sock(s)
{
    std::cout << "nick '" << n << "', msg '" << m << "', sock " << s << "\n";
}

const std::string &informevent::getsdata(const std::string &s) const
{
    if(s == "name")return nick;
    return msg;
}

int informevent::getidata(const std::string &) const
{
    return sock;
}
