#ifndef dud4_events_hh
#define dud4_events_hh

#include <string>

typedef enum
{
    E_NONE = 0,
    E_GLOBAL,
    E_INFORM
} eventtype;

class event
{
    eventtype type;
public:
    event(eventtype t);
    virtual ~event();
    virtual const std::string &getsdata(const std::string &) const = 0;
    virtual int getidata(const std::string &) const = 0;
    inline eventtype what() const { return type; }
};

class globalevent : public event
{
    std::string s;
public:
    globalevent(const std::string &msg);
    virtual const std::string &getsdata(const std::string &) const;
    virtual int getidata(const std::string &) const;
};

class informevent : public event
{
    std::string nick, msg;
    int sock;
public:
    informevent(const std::string &n, const std::string &m, int s);
    virtual const std::string &getsdata(const std::string &s) const;
    virtual int getidata(const std::string &) const;
};

#endif
