#include <csignal>
#include <iostream>
#include <unistd.h>

#include "task.hh"
#include "taskmanager.hh"
#include "servertask.hh"
#include "events.hh"

class taskmanager taskmanager;

class systemtask : public task
{
	unsigned n;
public:
	systemtask()
	{
		std::cout << "System task started.\n";
		n=0;
	}
    virtual bool tick()
    {
    	if(!(++n % (1000000*60/1000))) // once in minute
    	{
    		switch(rand() % 7)
    		{
    			case 0: taskmanager += globalevent("The vision bends abnormally a bit for a while."); break;
    			case 1: taskmanager += globalevent("Everything is foggy and blur."); break;
    			case 2: taskmanager += globalevent("Electricity crackles allaround."); break;
    			case 3: taskmanager += globalevent("The world is void."); break;
    			case 4: taskmanager += globalevent("You are quite alone."); break;
    			case 5: taskmanager += globalevent("Everything you hear is faint noises of electric arcs allaround."); break;
    			case 6: taskmanager += globalevent("You have never been as alone as you are now."); break;
    		}
    		std::cout << taskmanager.numtasks() << " tasks active\n";
    	}
    	return true;
   	}
};

class idletask: public task
{
};

static void ouch(int)
{
	std::cerr << "Interrupt signalled!\n";
}

int main(void)
{
	signal(SIGINT, ouch);
	signal(SIGPIPE, SIG_IGN);
	
	taskmanager.insert(new systemtask());
	taskmanager.insert(new servertask(6135));
	
	for(;;)
	{
		taskmanager.tick();
	}
	
	return 0;
}
